<?php

namespace Modules\CityManager\Providers;

use Illuminate\Support\ServiceProvider;
use Illuminate\Support\Facades\Blade;
use Livewire\Livewire;

class ModuleServiceProvider extends ServiceProvider
{
    protected string $moduleName = 'CityManager';

    public function register()
    {
        $this->app->register(RouteServiceProvider::class);
    }

    public function boot()
    {
        $this->registerViews();
        $this->registerLivewireViews();
        $this->registerMigrations();
        $this->registerConfig();
        $this->registerComponent();
        $this->registerLivewire();
    }

    protected function registerViews()
    {
        $moduleViewsPath = __DIR__ . '/../Views';
        $this->loadViewsFrom(
            $moduleViewsPath,
            strtolower($this->moduleName)
        );
    }

    protected function registerLivewireViews()
    {
        $moduleViewsPath = __DIR__ . '/../Views/livewire';
        $this->loadViewsFrom(
            $moduleViewsPath,
            strtolower($this->moduleName)
        );
    }

    protected function registerMigrations()
    {
        $this->loadMigrationsFrom(
            app_path('Modules/' . $this->moduleName . '/Database/Migrations')
        );
    }

    protected function registerConfig()
    {
        $path = app_path('Modules/' . $this->moduleName . '/Config/config.php');
        $this->mergeConfigFrom(
            $path,
            strtolower($this->moduleName)
        );
    }

    protected function registerLivewire()
    {
        Livewire::component('citymanagerinfo', \Modules\CityManager\Http\Livewire\CityManagerInfo::class);
    }

    protected function registerComponent()
    {
        //Blade::component('<name>', \Modules\<NAME>\Http\Components\<NAME>::class);
    }
}